// ShadowMapping Quad Shader (for debugging)
//////////////////////////////////////////////////////////////////////////////////////////////////////////

#type vertex
#version 330 core
layout (location = 0) in vec3 a_Pos;
layout (location = 1) in vec2 a_UV;

out vec2 UV;

void main()
{
    UV = a_UV;
    gl_Position = vec4(a_Pos, 1.0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#type framgent
#version 330 core
out vec4 fragColor;

in vec2 UV;

uniform sampler2D u_DepthMap;
uniform float u_NearPlane;
uniform float u_FarPlane;

// Required when using a perspective projection matrix
float LinearizeDepth(float depth)
{
    float z = depth * 2.0 - 1.0; // Back to normalized device coordinates
    return (2.0 * u_NearPlane * u_FarPlane) / (u_FarPlane + u_NearPlane - z * (u_FarPlane - u_NearPlane));
}

void main()
{             
    float depthValue = texture(u_DepthMap, UV).r;
    // fragColor = vec4(vec3(LinearizeDepth(depthValue) / u_F, P0); // perspective
    fragColor = vec4(vec3(depthValue), 1.0); // orthographic
}