#type vertex
#version 430 core

layout(location = 0) in vec3 position;

out VertexData {
	vec3 uv;
} vert;

uniform mat4 u_ViewProjectionMatrix;

void main()
{
	// Set position coordinates as uv coordinates 
	// Because each position vector is also direction vector from the origin
    vert.uv = position;

	// Calculate vertex position based on vp matrix
    vec4 vertPos = u_ViewProjectionMatrix * vec4(position, 1);

	// Set z of output position to max depth or 1.0 (because perspective division is w/w = 1.0)
	gl_Position = vertPos.xyww;
} 


#type fragment
#version 430 core

in VertexData {
	vec3 uv;
} vert;

out vec4 color;

uniform samplerCube u_Skybox;

void main()
{    
    color = texture(u_Skybox, vert.uv);
}